#ifndef FILETYPE_H
#define FILETYPE_H

typedef struct fileinfo {
	gchar *filename;
	gchar *title;
	gchar *artist;
	gchar *album;
	gchar *track;
	gchar *year;
} fileinfo;

typedef struct image_name_buffer {
	gchar *imagename;
	struct image_name_buffer *next;
} image_name_buffer;

void showfileinfo( fileinfo * info );
void freefileinfo( fileinfo * info );
struct fileinfo *dupfileinfo( struct fileinfo *old );
char *gentitle( fileinfo * info );
gint find_cover( char *filedir, struct fileinfo *info, struct image_name_buffer **first );
void netsearch( struct fileinfo *info, char *arts, char *tits );
void advnetsearch( struct fileinfo *info );
void get_file_info( char *filename );

struct fileinfo *mp3file( gchar * filename );
struct fileinfo *oggfile( gchar * filename );
struct fileinfo *cdinfo( gchar * filename );
struct fileinfo *lyrc_get_file_info( char *filename );

#endif
